theory cpp imports executions begin
  
subsection "Model relations"

(* extended communication *)
fun ecom :: "witnessed_execution \<Rightarrow> event rel" 
  where "ecom (X,rf,co) = rf \<union> co \<union> fr(X,rf,co) \<union> (co O rf)"
    
(* transactional synchronises-with *)
fun tsw :: "witnessed_execution \<Rightarrow> event rel"
  where "tsw (X,rf,co) = weaklift (ecom(X,rf,co), stxn X)"

(* happens-before *)    
fun hb :: "(witnessed_execution \<Rightarrow> event rel) \<Rightarrow> witnessed_execution \<Rightarrow> event rel"
  where "hb sw (X,rf,co) = (sw (X,rf,co) \<union> tsw (X,rf,co) \<union> po X)^+"
    
subsection "Model axioms"
    
fun HbCom :: "(witnessed_execution \<Rightarrow> event rel) \<Rightarrow> witnessed_execution \<Rightarrow> bool"
  where "HbCom sw (X,rf,co) = acyclic (hb sw (X,rf,co) O (com (X,rf,co))^*)"
    
end
  