theory no_txns_sc imports no_txns begin
         
(* from-read *)
fun fr :: "witnessed_execution \<Rightarrow> event rel"
  where "fr (X,rf,co) = (R X \<times> W X) \<inter> sloc X - (rf\<inverse> O (co\<inverse>)^*)"
    
(* communication *)
fun com :: "witnessed_execution \<Rightarrow> event rel" 
  where "com (X,rf,co) = rf \<union> co \<union> fr(X,rf,co)"
    
(* happens-before *)
fun hb :: "witnessed_execution \<Rightarrow> event rel" 
  where "hb (X,rf,co) = po X \<union> com(X,rf,co)"
    
fun TxnOrder :: "witnessed_execution \<Rightarrow> bool"
  where "TxnOrder (X,rf,co) = acyclic(stronglift(hb (X,rf,co), stxn X))"

fun Order :: "witnessed_execution \<Rightarrow> bool"
  where "Order (X,rf,co) = acyclic (hb (X,rf,co))"
    
(* The TxnOrder axiom adds nothing in the absence of transactions *)
theorem no_txns_sc:
  assumes "stxn X = {}"
  shows "Order (X,rf,co) \<longrightarrow> TxnOrder (X,rf,co)"
using no_txns_stronglift by (simp add: assms)
    
end
  